"{ Package: 'stx:goodies/regression' }"

"{ NameSpace: Smalltalk }"

LibraryDefinition subclass:#stx_goodies_regression
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_regression class methodsFor:'accessing - tests'!

testCaseNamesWithoutNamespace
    ^#(
     "/ 'SunitXMLOutputTest'
    'ProjectDefinitionTests'
    'CoverageInstrumentationTest'
    'AssociationTests'
    'BinaryIOTests'
    'BinaryTreeTester'
    "/ 'BlockTest'
    'CharacterTests'
    'CollectionTests'
    'CompilerTest'
    'ComplexTest'
    "/ 'STCCompilerTests'
    "/ 'DebuggerTest'
    "/ 'DeepCopyTests'
    'DelayTest'
    'DictionaryTest'
    'EnumerationTests'
    'ExceptionTest'
    "/ 'ExternalInterfaceTests'
    "/ 'FileOpenTest'
    'FileStreamTest'
    'FloatTest'
    'FractionTest'
    "/ 'GCTest'
    "/ 'GraphicDrawingTest'
    "/ 'HTMLParserTests'
    "/ 'ImageReaderTest'
    'IntegerTest'
    'JavaScriptTests'
    "/ 'MeasurementValueTests'
    "/ 'MemoryTest'
    'NumberTest'
    'ParserTest'
    'ScaledDecimalTest'
    "/ 'SemaphoreTest'
    "/ 'SharedQueueTest'
    'SmallIntegerTest'
    "/ 'SortTests'
    'StringTests'
    'StreamTests'
    'TimeAndDateTest'
    'TimeDurationTest'
    "/ 'URLTest'
    "/ 'XMLCoderTests'
    "/ 'ZipArchiveTests'
    'ClassBuilderTests'
    "/ 'CompilerTests2'
    'ChangeSetTests'
    'FilenameTests'
    'ProjectDefinitionTests'
    'ClassDescriptionTests'
    'SnapshotRestartTests'
    'MakefileTests'
    'TSTreeTests'
    'TSMultiTreeTests'
    "/ 'VMCrashTests'
    'ProcessTest'
    'PipeStreamTest'
    'JITTest'
    )

    "Modified: / 18-11-2014 / 11:54:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

testSuite

    | suite |

    suite := TestSuite named: self package.
    self testCaseNamesWithoutNamespace do:[:className |
	|fullName|

	fullName := ('RegressionTests::',className).
	('Loading ',className,'...') infoPrintCR.
	Smalltalk fileInClass:fullName package:self package.
	(Smalltalk classNamed:fullName) isNil ifTrue:[
	    ('**** Ouch - missing class: "',fullName,'"') infoPrintCR.
	] ifFalse:[
	    suite addTest:(Smalltalk classNamed:fullName) suite.
	].
    ].

    ^suite

    "Created: / 03-08-2011 / 09:19:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_goodies_regression class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
	#'exept:libcrypt'    "loaded lazily by CryptTests - SHA256Stream - referenced by RegressionTests::CryptTests>>test06_sha256 "
	#'stx:goodies'    "no project def - CharacterEncoderCodeGenerator - referenced by RegressionTests::CharacterTests>>test01CaseTesting "
    )

    "Modified: / 03-03-2014 / 12:00:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

mandatoryPreRequisites
    "list packages which are mandatory as a prerequisite.
     This are packages containing superclasses of my classes and classes which
     are extended by myself.
     They are mandatory, because we need these packages as a prerequisite for loading and compiling.
     This method is generated automatically,
     by searching along the inheritance chain of all of my classes."

    ^ #(
	#'stx:goodies/sunit'    "TestAsserter - superclass of RegressionTests::VMCrashTestCase"
	#'stx:libbasic'    "Autoload - superclass of RegressionTests::AssociationTests"
    )
!

referencedPreRequisites
    "list packages which are a prerequisite, because they contain
     classes which are referenced by my classes.
     We do not need these packages as a prerequisite for loading or compiling.
     This method is generated automatically,
     by searching all classes (and their packages) which are referenced by my classes."

    ^ #(
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites"

    ^ #(
    )
! !

!stx_goodies_regression class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        (#'RegressionTests::CryptTests' autoload)
        (#'RegressionTests::TypedArrayTests' autoload)
        (#'RegressionTests::UninterpretedBytesTest' autoload)
        #'stx_goodies_regression'
        (#'RegressionTests::CompressionStreamTest' autoload)
        (#'RegressionTests::LinkedListTest' autoload)
        (#'RegressionTests::QueueTest' autoload)
        (#'RegressionTests::Win32OLETests' autoload)
        (#'RegressionTests::Win32OperatingSystemTest' autoload)
        (#'RegressionTests::HTMLParserTests' autoload)
        (#'RegressionTests::HTTPServerTests' autoload)
        (#'RegressionTests::CompilerTests2' autoload)
        (#'RegressionTests::CompilerTests2ExternalBytes' autoload)
        (#'RegressionTests::AssociationTests' autoload)
        (#'RegressionTests::BecomeTests' autoload)
        (#'RegressionTests::BehaviorLookupObjectTests' autoload)
        (#'RegressionTests::BinaryIOTests' autoload)
        (#'RegressionTests::BinaryTreeTester' autoload)
        (#'RegressionTests::BlockTest' autoload)
        (#'RegressionTests::BreakpointTests' autoload)
        (#'RegressionTests::CECollectionExtensionTest' autoload)
        (#'RegressionTests::CESequenceableCollectionExtensionTest' autoload)
        (#'RegressionTests::CEStringExtensionTest' autoload)
        (#'RegressionTests::CachedValueTest' autoload)
        (#'RegressionTests::CharacterEncoderTests' autoload)
        (#'RegressionTests::CharacterSetTests' autoload)
        (#'RegressionTests::CharacterTests' autoload)
        (#'RegressionTests::ClassAndMethodCompilingTestCase' autoload)
        (#'RegressionTests::ClassDescriptionTests' autoload)
        (#'RegressionTests::ClassWithoutVersionMethod' autoload)
        (#'RegressionTests::CollectionTests' autoload)
        (#'RegressionTests::CompilerTest' autoload)
        (#'RegressionTests::ComplexTest' autoload)
        (#'RegressionTests::ContextTest2' autoload)
        (#'RegressionTests::CoverageInstrumentationTest' autoload)
        (#'RegressionTests::DebuggerTest' autoload)
        (#'RegressionTests::DeepCopyTests' autoload)
        (#'RegressionTests::DelayTest' autoload)
        (#'RegressionTests::DictionaryTest' autoload)
        (#'RegressionTests::DoubleMetaphoneStringComparatorTest' autoload)
        (#'RegressionTests::EnumerationTests' autoload)
        (#'RegressionTests::ExceptionTest' autoload)
        (#'RegressionTests::ExternalInterfaceTests' autoload)
        (#'RegressionTests::ExternalStreamTest' autoload)
        (#'RegressionTests::FileOpenTest' autoload)
        (#'RegressionTests::FileStreamTest' autoload)
        (#'RegressionTests::FilenameTests' autoload)
        (#'RegressionTests::FloatTest' autoload)
        (#'RegressionTests::FractionTest' autoload)
        (#'RegressionTests::GCTest' autoload)
        (#'RegressionTests::GraphicDrawingTest' autoload)
        (#'RegressionTests::ImageReaderTest' autoload)
        (#'RegressionTests::IntegerTest' autoload)
        (#'RegressionTests::JITTest' autoload)
        (#'RegressionTests::JavaScriptTests' autoload)
        (#'RegressionTests::KoelnerPhoneticCodeStringComparatorTest' autoload)
        (#'RegressionTests::LabelResizingTest' autoload)
        (#'RegressionTests::LargeFloatTest' autoload)
        (#'RegressionTests::LiteralsInMethodTests' autoload)
        (#'RegressionTests::LoggedStreamTests' autoload)
        (#'RegressionTests::MakefileTests' autoload)
        (#'RegressionTests::ManyProcessesTest' autoload)
        (#'RegressionTests::MeasurementValueTests' autoload)
        (#'RegressionTests::MemoryTest' autoload)
        (#'RegressionTests::MetaNumbersTest' autoload)
        (#'RegressionTests::MiracodeStringComparatorTest' autoload)
        (#'RegressionTests::MySQLSoundexStringComparatorTest' autoload)
        (#'RegressionTests::NumberTest' autoload)
        (#'RegressionTests::OS_OLE_Tests' autoload)
        (#'RegressionTests::OperatingSystemTest' autoload)
        (#'RegressionTests::OperationInQueueTests' autoload)
        (#'RegressionTests::PTYTest' autoload)
        (#'RegressionTests::ParserTests' autoload)
        (#'RegressionTests::PipeStreamTest' autoload)
        (#'RegressionTests::PowerSetTests' autoload)
        (#'RegressionTests::ProcessTest' autoload)
        (#'RegressionTests::ProjectDefinitionTests' autoload)
        (#'RegressionTests::QuickTestRunner' autoload)
        (#'RegressionTests::STCCompilerTests' autoload)
        (#'RegressionTests::ScaledDecimalTest' autoload)
        (#'RegressionTests::SegmentedOrderedCollectionTests' autoload)
        (#'RegressionTests::SelectorNamespacesTests' autoload)
        (#'RegressionTests::SemaphoreTest' autoload)
        (#'RegressionTests::ServerSocketTest' autoload)
        (#'RegressionTests::SharedQueueTest' autoload)
        (#'RegressionTests::SmallIntegerTest' autoload)
        (#'RegressionTests::SnapshotRestartTests' autoload)
        (#'RegressionTests::SocketTests' autoload)
        (#'RegressionTests::SortTests' autoload)
        (#'RegressionTests::SoundexStringComparatorTest' autoload)
        (#'RegressionTests::StackFrameTest' autoload)
        (#'RegressionTests::StreamTests' autoload)
        (#'RegressionTests::StringTests' autoload)
        (#'RegressionTests::SunitXMLOutputTest' autoload)
        (#'RegressionTests::TSTreeTests' autoload)
        (#'RegressionTests::TestDialogs1' autoload)
        (#'RegressionTests::TimeAndDateTest' autoload)
        (#'RegressionTests::TimeDurationTest' autoload)
        (#'RegressionTests::URLTest' autoload)
        (#'RegressionTests::UTF8TestClass' autoload)
        (#'RegressionTests::VMCrashTestCase' autoload)
        (#'RegressionTests::WeakCollectionTest' autoload)
        (#'RegressionTests::WritingToTranscriptOrStdoutTest' autoload)
        (#'RegressionTests::WrongMethodCalledTest' autoload)
        (#'RegressionTests::XMLCoderTests' autoload)
        (#'RegressionTests::ZipArchiveTests' autoload)
        (#'RegressionTests::ChangeSetTests' autoload)
        (#'RegressionTests::ClassBuilderTests' autoload)
        (#'RegressionTests::TSMultiTreeTests' autoload)
        (#'RegressionTests::VMCrashTests' autoload)
    )
!

extensionMethodNames
    "list class/selector pairs of extensions.
     A correponding method with real names must be present in my concrete subclasses"

    ^ #(
    )
! !

!stx_goodies_regression class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Class Library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright eXept Software AG 1998-2016'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'eXept addOns'
! !

!stx_goodies_regression class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

